' V1.2
'   update: the ANWB changed the site. Images are now composed of layers
'           with different information. this script extracts the background
'           and the two traffic layers
' V1.1.1
'   update: this vbs was regognized as containing the VBS/PSYME virus
'           I cut the trigger line in two (see below)
' V1.1
'   update: ANWB changed site layout, adaption needed
' V1.0.3
'   bug fix: sometimes got errors on the png file
' V1.0.2
'   bug fix: problems when no 'cut' arg was specified
' V1.0.1
'   bug fix: showing all of nederland did not work
'   made the cut-out-area into parameter (e.g. "355,94,190,180" = x,y,w,h)
'   all images generated in a sub folder of Scripts
'   added image option to rotate
'   added filter to hide image when no heavy traffic
' V1.0.0
'   initial version

Function ANWB_Image(regio,cut)
    ' do not remove the plus in the next line, some virus checkers will warn for VBS/PSYME
    anwbURL         = "http:/"+"/www2.anwb.nl/"
    ANWBDir         = scriptsDir+"ANWB\"

    if (regio="") then
        pageURL      = anwbURL +"verkeer/verkeersinformatie_nederland.nl.html"
        imageIn1Path  = ANWBDir+"ANWB_NL1.gif"
        imageIn2Path  = ANWBDir+"ANWB_NL2.gif"
        imageIn3Path  = ANWBDir+"ANWB_NL3.gif"
        imageOutPath = ANWBDir+"ANWB_NL.png"
    else
        pageURL      = anwbURL +"verkeer/popup_regioverkeerssituatie_"+regio+".nl.html"
        imageIn1Path  = ANWBDir+"ANWB_"+regio+"1.gif"
        imageIn2Path  = ANWBDir+"ANWB_"+regio+"2.gif"
        imageIn3Path  = ANWBDir+"ANWB_"+regio+"3.gif"
        imageOutPath = ANWBDir+"ANWB_"+regio+".png"
    end if
    if (not existsFolder(ANWBDir)) then
        createFolder(ANWBDir)
    end if
    pageString = getPageFromURL(pageURL)
    image1URL  = anwbURL+isolateFromPage(pageString, "id=""basis_layer_", "verkeer/images/", """", true, false)
    image2URL  = anwbURL+isolateFromPage(pageString, "id=""jam_layer2_" , "verkeer/images/", """", true, false)
    image3URL  = anwbURL+isolateFromPage(pageString, "id=""jam_layer_"  , "verkeer/images/", """", true, false)
    refresh    = not(exists(imageOutPath))

    if (regRead("ANWB-last1")<>image1URL or not(exists(imageIn1Path))) then
        theImage = getImageFromURL(image1URL)
        saveImage theImage,imageIn1Path
        regWrite "ANWB-last1",image1URL
        refresh = true
    end if
    if (regRead("ANWB-last2")<>image2URL or not(exists(imageIn2Path))) then
        theImage = getImageFromURL(image2URL)
        saveImage theImage,imageIn2Path
        regWrite "ANWB-last2",image2URL
        refresh = true
    end if
    if (regRead("ANWB-last3")<>image3URL or not(exists(imageIn3Path))) then
        theImage = getImageFromURL(image3URL)
        saveImage theImage,imageIn3Path
        regWrite "ANWB-last3",image3URL
        refresh = true
    end if

    if (refresh) then
        cmds = ""
        cmds = cmds+"-Read """&imageIn1Path&""" "
        cmds = cmds+"-Read """&imageIn2Path&""" "
        cmds = cmds+"-Read """&imageIn3Path&""" "
        if (len(cut)<>0) then
            cmds = cmds+"-Cut "+cut+" "
        end if
        cmds = cmds+"-Border 2,160,160,160 "
        cmds = cmds+"-Border 1,0,0,0 "
        'cmds = cmds+"-ANWBFilter 0 "    ' use 10-50, will hide the png if no heavy traffic, tune the threshold arg
        convertImage imageOutPath,cmds
    end if

    ANWB_Image = imageOutPath
End Function

'===============================================================================================
'======================================= GENERAL UTILS =========================================
'===============================================================================================
set shell     = CreateObject("WScript.Shell")
set http      = CreateObject("WinHttp.WinHttpRequest.5.1")
' use this line if you are behind a proxy:
'http.SetProxy 2,"xxx.xxx.xxx.xxx:xxx","*.yourcompany.com"
set stream    = CreateObject("ADODB.Stream")
set filesys   = CreateObject("Scripting.FileSystemObject")
scriptsDir    = "C:\Program Files\Samurize\Scripts\"


private function regRead(key)
	On Error Resume Next
    regRead = shell.RegRead ("HKCU\Software\tombrus\"&key)
end function

private sub regWrite(key,value)
    shell.RegWrite "HKCU\Software\tombrus\"&key,value
end sub

private function getPageFromURL(url)
    ' use this line if you are behind a caching proxy:
    'http.Open "GET", url&"?"&getRandomNum(), False
    http.Open "GET", url, False
    http.Send
    getPageFromURL = http.ResponseText
end function

private function getImageFromURL(url)
    ' use this line if you are behind a caching proxy:
    'http.Open "GET", url&"?"&getRandomNum(), False
    http.Open "GET", url, False
    http.Send
    getImageFromURL = http.ResponseBody
end function

private sub saveImage(theImage,imagePath)
    stream.Type = 1 			    ' 1=adTypeBinary
    stream.Open
    stream.Write theImage
    stream.SaveToFile imagePath, 2 	' 2=adSaveCreateOverWrite
    stream.Close
end sub

private sub createFolder(folder)
    filesys.createFolder(folder)
end sub

private function exists(file)
    exists = filesys.FileExists(file)
end function

private function existsFolder(folder)
    existsFolder = filesys.FolderExists(folder)
end function

private function isolateFromPage(page,anchor,startPattern,endPattern,includeStart,includeEnd)
    s   = page
    pos = InStr(s, anchor)
    if (pos=0) then
        s = "ANCHOR NOT FOUND: "+anchor
    else
        s = right(s,len(s)-pos)
        pos = InStr(s, startPattern)
        if (pos=0) then
            s = "START NOT FOUND: "+startPattern
        else
            length          = len(s)-pos+1-len(startPattern)
            nextMatchStart  = 1
            if (includeStart) then
                length         = length+len(startPattern)
                nextMatchStart = len(startPattern)+1
            end if
            s   = right(s,length)
            pos = InStr(nextMatchStart,s,endPattern)
            if (pos=0) then
                s = "END NOT FOUND: "+endPattern
            else
                length = pos-1
                if (includeEnd) then
                    length = length+len(endPattern)
                end if
                s = left(s,length)
            end if
        end if
    end if
    isolateFromPage = s
end function

private sub convertImage(ImageOut,cmds)
    tmpFile = ImageOut&"-tmp"
    classpath = scriptsDir&"imageConverter.jar"
    javaCmd = "java -classpath """&classpath&""" com.tombrus.imageConverter.Main "+cmds+"-Write """&tmpFile&""""
    shell.run javaCmd,0,true
    if filesys.FileExists(tmpFile) Then
        filesys.CopyFile tmpFile,ImageOut,true
        filesys.DeleteFile tmpFile,true
    end if
end sub

private function getRandomNum
    randomize timer
    getRandomNum = int(rnd * 1000)
end function